#include <jni.h>
#include <iostream>
#include "net_nanex_NxCoreClass.h"
#include "NxCoreAPI/NxCoreAPI.h"
#include "NxCoreAPI/NxCoreAPI_Wrapper_C++.h"
#include "robin_hood.h"
#define CHECK_EXCEPTIONS
#ifndef MAX_PATH
#define MAX_PATH 4096
#endif
using namespace std;

struct OptionLookupResult {
	jobject jSymbol;
	NxString* pExpectedUnderlyingNxString;
	jobject jUnderlying;
	NxString* pExpectedSeriesChainNxString;
	jobject jSeriesChain;
	NxString* pExpectedSpecialSettleNxString;
	jobject jSpecialSettle;
};

thread_local NxCoreClass NxCore;
int __stdcall OnNxCoreCallbackSetReverseLookup(const NxCoreSystem* pNxCoreSys, const NxCoreMessage* pNxCoreMsg);
class ThreadData {
public:
int bLoadedLibrary = 0;
int bBeforeSpin = 1;
jobject objectIface = NULL;
jobject NxCoreSysIface =NULL;
jclass StringClass = NULL;
 
jmethodID methodStatus = NULL;
jmethodID methodExgQuoteEquity = NULL;
jmethodID methodExgQuoteOption = NULL;
jmethodID methodMMQuoteEquity = NULL;
jmethodID methodMMQuoteOption = NULL;
jmethodID methodTradeEquity = NULL;
jmethodID methodTradeOption = NULL;
jmethodID methodCategoryEquity = NULL;
jmethodID methodCategoryOption = NULL;
jmethodID methodSymbolChangeEquity = NULL;
jmethodID methodSymbolChangeOption = NULL;
jmethodID methodSymbolSpinEquity = NULL;
jmethodID methodSymbolSpinOption = NULL;
jmethodID methodUserSymbolSpinEquity = NULL;
jmethodID methodUserSymbolSpinOption = NULL;
jmethodID methodUserTapeList = NULL;
jmethodID methodUserAPIList = NULL;
 
JNIEnv* env = nullptr;

jfieldID arrayFid = NULL;
jobject array_Val = NULL;
jintArray jMyArray = NULL;
jobject jStringNull = nullptr;
const char* charNull = "";
NxCoreSystem* m_pNxCoreSys = nullptr;
NxCoreMessage* m_pNxCoreMsg = nullptr;

char* pBuffSys = nullptr;
char* pBuffExg = nullptr;
char* pBuffMM = nullptr;
char* pBuffTrade = nullptr;
char* pBuffCategory = nullptr;
char* pBuffSymbolChange = nullptr;
char* pBuffSymbolChangeOption = nullptr;
char* pBuffSymbolSpin = nullptr;
char* pBuffCoreHeader = nullptr;
char* pBuffOptionHeader = nullptr;
char* pBuffSymbolUserData = nullptr;
char* pBuffContractUserData = nullptr;
char* pBuffUnderlyingUserData = nullptr;
char* pBuffState = nullptr;
NxDate* pBuffDate = nullptr;
NxCoreTapeFile* pBuffTapeFile = nullptr;
NxCoreAPIDLLFile* pBuffAPIDLLFile = nullptr;
NxCore3Ext* pBuffNxCore3Ext = nullptr;
 
jobjectArray jStringStausArray = NULL;


//symbol filtering vairables
char symbolFilterEnable = 0;
robin_hood::unordered_flat_map<std::string, size_t> symbolFilterLookup;
robin_hood::unordered_flat_map<std::string, size_t> symbolExcludeLookup;
std::string StartSymbol = "";
std::string EndSymbol = "";

OptionLookupResult* OptionLookupAtom[65536];
jobject* SymbolLookupAtom[256];
robin_hood::unordered_flat_map<size_t, OptionLookupResult*> OptionLookup;
robin_hood::unordered_flat_map<size_t, jobject> DefinedStringLookup[256];
robin_hood::unordered_flat_map<size_t, jobject> SymbolLookup[256];
robin_hood::unordered_flat_map<size_t, jobject> SymbolLookupOld[256];
robin_hood::unordered_flat_map<std::string, size_t> SymbolNxStringLookup[256];
jobject DateAndStrikeLookup[65536];
robin_hood::unordered_flat_map<size_t, jobject> MMLookup;

jstring CategoryLookup[256];
jobjectArray CategoryFieldNameLookup[256];
jobjectArray CategoryFieldInfoLookup[256];
jobjectArray CategoryDataString;
jobjectArray MMStateString;
jobjectArray EmptyArray;

jobject jStringPermissionSet = nullptr;


void SetSymbolFilterUserData(const NxCoreMessage* pNxCoreMsg) {
	size_t exg;
	if (symbolFilterEnable == 1) {
		exg = symbolFilterLookup[pNxCoreMsg->coreHeader.pnxStringSymbol->String];
		if (exg == 256 || exg == pNxCoreMsg->coreHeader.ListedExg) {
			pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 = 1;
		}
		else
			pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 = 0;
	}
	else if (symbolFilterEnable == 2) {
		exg = symbolExcludeLookup[pNxCoreMsg->coreHeader.pnxStringSymbol->String];
		if (exg == 256 || exg == pNxCoreMsg->coreHeader.ListedExg) {
			pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 = 0;
		}
		else
			pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 = 1;
	}
	else if (symbolFilterEnable == 3) {
		for (int i = 0; i < StartSymbol.size(); i++) {
			if (i >= strlen(pNxCoreMsg->coreHeader.pnxStringSymbol->String) || StartSymbol.at(i) > pNxCoreMsg->coreHeader.pnxStringSymbol->String[i]) {
				pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 = 0;
				return;
			}
			if (StartSymbol.at(i) < pNxCoreMsg->coreHeader.pnxStringSymbol->String[i])// found charecter greater than starting so done checking
				break;
		}
		if (EndSymbol.size()) {// no end string means include all greater than symbol
			for (int i = 0; i < strlen(pNxCoreMsg->coreHeader.pnxStringSymbol->String); i++) {
				if (i >= EndSymbol.size() || EndSymbol.at(i) < pNxCoreMsg->coreHeader.pnxStringSymbol->String[i]) {
					pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 = 0;
					return;
				}
				if (EndSymbol.at(i) > pNxCoreMsg->coreHeader.pnxStringSymbol->String[i])// found charecter less than ending string so done checking
					break;
			}
		}
		pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 = 1;
	}
}
inline jobject GetjStringSymbol(NxString* pNxString, unsigned char exg) {
	jobject jString;
	if (pNxString) {
		if (!SymbolLookupAtom[exg]) {
			SymbolLookupAtom[exg] = new jobject[65536];
			if (SymbolLookupAtom[exg])
				memset(SymbolLookupAtom[exg], 0, 65536 * sizeof(jobject));
			else
				return nullptr;
		}
		if (pNxString->Atom != NxATOM_MAX_16BIT) {
			jString = SymbolLookupAtom[exg][pNxString->Atom];
			if (jString)
				return jString;
		}
		else {
			auto iter = SymbolLookup[exg].find((size_t)pNxString->String);
			if (iter != SymbolLookup[exg].end())
				return iter->second;
		}
		jstring jLocalTemp = env->NewStringUTF(pNxString->String);
		jString = env->NewGlobalRef(jLocalTemp);
		env->DeleteLocalRef(jLocalTemp);
		if (pNxString->Atom != NxATOM_MAX_16BIT)
			SymbolLookupAtom[exg][pNxString->Atom] = jString;
		else
			SymbolLookup[exg][(size_t)pNxString->String] = jString;
		SymbolNxStringLookup[exg][std::string(pNxString->String)] = (size_t)pNxString;
	}
	else
		jString = jStringNull;
	return jString;
}
inline OptionLookupResult* GetjStringOption(NxString* pNxStringSymbol, NxOptionHdr* pnxOptionHdr) {
	NxString* pNxStringUnderlying = pnxOptionHdr->pnxsUnderlying;
	NxString* pNxStringSeriesChain = pnxOptionHdr->pnxsSeriesChain;
	NxString* pNxStringSpecialSettle = pnxOptionHdr->pnxsSpecialSettle;
	OptionLookupResult* pResult;
	jstring jLocalTemp;
	if (pNxStringSymbol) {
		if ((pNxStringSymbol->Atom != NxATOM_MAX_16BIT && (pResult = OptionLookupAtom[pNxStringSymbol->Atom])) || (pNxStringSymbol->Atom == NxATOM_MAX_16BIT && (pResult = OptionLookup[(size_t)pNxStringSymbol->String]))) {
			if (pResult->pExpectedUnderlyingNxString != pNxStringUnderlying) {
				if (pResult->jUnderlying)
					env->DeleteGlobalRef(pResult->jUnderlying);
				if (pNxStringUnderlying) {
					jLocalTemp = env->NewStringUTF(pNxStringUnderlying->String);
					pResult->jUnderlying = env->NewGlobalRef(jLocalTemp);
					env->DeleteLocalRef(jLocalTemp);
					pResult->pExpectedUnderlyingNxString = pNxStringUnderlying;
				}
				else {
					pResult->jUnderlying = 0;
					pResult->pExpectedUnderlyingNxString = 0;
				}
			}
			if (pResult->pExpectedSeriesChainNxString != pNxStringSeriesChain) {
				if (pResult->jSeriesChain)
					env->DeleteGlobalRef(pResult->jSeriesChain);
				if (pNxStringSeriesChain) {
					jLocalTemp = env->NewStringUTF(pNxStringSeriesChain->String);
					pResult->jSeriesChain = env->NewGlobalRef(jLocalTemp);
					env->DeleteLocalRef(jLocalTemp);
					pResult->pExpectedSeriesChainNxString = pNxStringSeriesChain;
				}
				else {
					pResult->jSeriesChain = 0;
					pResult->pExpectedSeriesChainNxString = 0;
				}
			}
			if (pResult->pExpectedSpecialSettleNxString != pNxStringSpecialSettle) {
				if (pResult->jSpecialSettle)
					env->DeleteGlobalRef(pResult->jSpecialSettle);
				if (pNxStringSpecialSettle) {
					jLocalTemp = env->NewStringUTF(pNxStringSpecialSettle->String);
					pResult->jSpecialSettle = env->NewGlobalRef(jLocalTemp);
					env->DeleteLocalRef(jLocalTemp);
					pResult->pExpectedSpecialSettleNxString = pNxStringSpecialSettle;
				}
				else {
					pResult->jSpecialSettle = 0;
					pResult->pExpectedSpecialSettleNxString = 0;
				}
			}
		}
		else {
			pResult = new OptionLookupResult;
			if (pResult) {
				memset(pResult, 0, sizeof(OptionLookupResult));
				jLocalTemp = env->NewStringUTF(pNxStringSymbol->String);
				pResult->jSymbol = env->NewGlobalRef(jLocalTemp);
				env->DeleteLocalRef(jLocalTemp);
				if (pNxStringUnderlying) {
					jLocalTemp = env->NewStringUTF(pNxStringUnderlying->String);
					pResult->jUnderlying = env->NewGlobalRef(jLocalTemp);
					env->DeleteLocalRef(jLocalTemp);
					pResult->pExpectedUnderlyingNxString = pNxStringUnderlying;
				}
				if (pNxStringSeriesChain) {
					jLocalTemp = env->NewStringUTF(pNxStringSeriesChain->String);
					pResult->jSeriesChain = env->NewGlobalRef(jLocalTemp);
					env->DeleteLocalRef(jLocalTemp);
					pResult->pExpectedSeriesChainNxString = pNxStringSeriesChain;
				}
				if (pNxStringSpecialSettle) {
					jLocalTemp = env->NewStringUTF(pNxStringSpecialSettle->String);
					pResult->jSpecialSettle = env->NewGlobalRef(jLocalTemp);
					env->DeleteLocalRef(jLocalTemp);
					pResult->pExpectedSpecialSettleNxString = pNxStringSpecialSettle;
				}
				if (pNxStringSymbol->Atom != NxATOM_MAX_16BIT)
					OptionLookupAtom[pNxStringSymbol->Atom] = pResult;
				else
					OptionLookup[(size_t)pNxStringSymbol->String] = pResult;

			}
		}
		return pResult;
	}
	return nullptr;
}
inline NxString* GetjNxStringSymbol(jstring jSymbol, unsigned char exg) {
	if (jSymbol && exg < 256) {

		const char* charArraySymbol = env->GetStringUTFChars(jSymbol, 0);
		NxString* pNxString = (NxString*)SymbolNxStringLookup[exg][std::string(charArraySymbol)];
		env->ReleaseStringUTFChars(jSymbol, charArraySymbol);
		return pNxString;
	}
	return nullptr;
}
inline jobject GetjStringDateAndStrike(NxString* pNxString) {
	jobject jString;
	unsigned short key;
	if (pNxString) {
		//only 2 char Strings. convert string to key.
		if (pNxString->String[0])
			key = ((unsigned short)pNxString->String[1] << 8) | pNxString->String[0];
		else
			key = 0;
		if (DateAndStrikeLookup[key]) {
			jString = DateAndStrikeLookup[key];
		}
		else {
			char DateAndStrike[3];
			strncpy(DateAndStrike, pNxString->String, 2);
			DateAndStrike[2] = 0;
			jstring jLocalTemp = env->NewStringUTF(DateAndStrike);
			jString = env->NewGlobalRef(jLocalTemp);
			DateAndStrikeLookup[key] = jString;
			env->DeleteLocalRef(jLocalTemp);
		}
	}
	else
		jString = jStringNull;
	return jString;
}
inline jobject GetjStringMM(NxString* pNxString) {
	jobject jString;
	if (pNxString) {
		if (MMLookup[(size_t)pNxString->String]) {
			jString = MMLookup[(size_t)pNxString->String];
		}
		else {
			jobject jLocalTemp = env->NewStringUTF(pNxString->String);
			jString = env->NewGlobalRef(jLocalTemp);
			env->DeleteLocalRef(jLocalTemp);
			MMLookup[(size_t)pNxString->String] = jString;
		}
	}
	else
		jString = jStringNull;
	return jString;
}
inline jobject GetjStringSymbolOld(NxString* pNxString, int exg) {
	jobject jString;
	if (pNxString && exg < 256) {
		if (SymbolLookupOld[exg][(size_t)pNxString->String]) {
			jString = SymbolLookupOld[exg][(size_t)pNxString->String];
		}
		else {
			jobject jLocalTemp = env->NewStringUTF(pNxString->String);
			jString = env->NewGlobalRef(jLocalTemp);
			env->DeleteLocalRef(jLocalTemp);
			SymbolLookupOld[exg][(size_t)pNxString->String] = jString;
		}
	}
	else
		jString = jStringNull;
	return jString;
}
inline jobject GetjStringCategory(NxString* pNxString, int ixCategory) {
	jobject jString;
	if (pNxString && ixCategory < 256) {
		if (CategoryLookup[ixCategory]) {
			jString = CategoryLookup[ixCategory];
		}
		else {
			jobject jLocalTemp = env->NewStringUTF(pNxString->String);
			jString = env->NewGlobalRef(jLocalTemp);
			env->DeleteLocalRef(jLocalTemp);
			CategoryLookup[ixCategory] = (jstring)env->NewGlobalRef(jString);
		}
	}
	else
		jString = jStringNull;
	return jString;
}
inline jobjectArray GetjArrayCategoryFieldName(NxCategoryField* pnxFields, unsigned short NFields, int ixCategory) {
	if (CategoryFieldNameLookup[ixCategory])
		return CategoryFieldNameLookup[ixCategory];
	jobjectArray jStringFieldNameArray = (jobjectArray)env->NewObjectArray(NFields, StringClass, jStringNull);
	CategoryFieldNameLookup[ixCategory] = (jobjectArray)env->NewGlobalRef(jStringFieldNameArray);
	env->DeleteLocalRef(jStringFieldNameArray);
	jstring jName;
	for (int i = 0; i < NFields; i++) {
		if (pnxFields[i].FieldName) {
			jName = env->NewStringUTF(pnxFields[i].FieldName);
			env->SetObjectArrayElement(CategoryFieldNameLookup[ixCategory], i, jName);
			env->DeleteLocalRef(jName);
		}
	}
	return CategoryFieldNameLookup[ixCategory];
}
inline jobjectArray GetjArrayCategoryFieldInfo(NxCategoryField* pnxFields, unsigned short NFields, int ixCategory) {
	if (CategoryFieldInfoLookup[ixCategory])
		return CategoryFieldInfoLookup[ixCategory];
	jobjectArray jStringArray = (jobjectArray)env->NewObjectArray(NFields, StringClass, jStringNull);
	CategoryFieldInfoLookup[ixCategory] = (jobjectArray)env->NewGlobalRef(jStringArray);
	env->DeleteLocalRef(jStringArray);

	jstring jInfo;
	for (int i = 0; i < NFields; i++) {
		if (pnxFields[i].FieldInfo) {
			jInfo = env->NewStringUTF(pnxFields[i].FieldInfo);
			env->SetObjectArrayElement(CategoryFieldInfoLookup[ixCategory], i, jInfo);
			env->DeleteLocalRef(jInfo);
		}
	}

	return CategoryFieldInfoLookup[ixCategory];
}
inline bool checkSymbol(const NxCoreMessage* pNxCoreMsg) {
	if (!symbolFilterEnable || pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 == 1)
		return true;
	if (bBeforeSpin) {//symbol spin has not happened yet.
		SetSymbolFilterUserData(pNxCoreMsg);
		if (pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 == 1)
			return true;
	}
	return false;
}
int SetReverseLookup(const NxCoreSystem* pNxCoreSys, const NxCoreMessage* pNxCoreMsg) {
	if (symbolFilterEnable)
		SetSymbolFilterUserData(pNxCoreMsg);
	if (pNxCoreMsg->coreHeader.pnxOptionHdr)
		SymbolNxStringLookup[10][std::string(pNxCoreMsg->coreHeader.pnxStringSymbol->String) + std::to_string(pNxCoreMsg->coreHeader.pnxOptionHdr->nxExpirationDate.NDays).append(1, pNxCoreMsg->coreHeader.pnxOptionHdr->PutCall == 0 ? 'C' : 'P') + std::to_string(pNxCoreMsg->coreHeader.pnxOptionHdr->strikePrice)] = (size_t)pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike;
	else
		SymbolNxStringLookup[pNxCoreMsg->coreHeader.ListedExg][std::string(pNxCoreMsg->coreHeader.pnxStringSymbol->String)] = (size_t)pNxCoreMsg->coreHeader.pnxStringSymbol;
	return NxCALLBACKRETURN_CONTINUE;
}
int inline Callback(const NxCoreSystem* pNxCoreSys, const NxCoreMessage* pNxCoreMsg)
{
	//ThreadData* pTD = &td;
	jobject jStringMM = nullptr;
	jobject jStringSymbol = nullptr;
	OptionLookupResult* pOption;
	NxCategoryField* pnxFields;
	int ret = NxCALLBACKRETURN_CONTINUE;

	m_pNxCoreSys = (NxCoreSystem*)pNxCoreSys;
	m_pNxCoreMsg = (NxCoreMessage*)pNxCoreMsg;
	if (pNxCoreMsg->pnxCore3Ext)
		memcpy(pBuffNxCore3Ext, pNxCoreMsg->pnxCore3Ext, 24);
	else
		memset(pBuffNxCore3Ext, 0, 24);
	switch (pNxCoreMsg->MessageType) {
	case NxMSG_STATUS:
		memcpy(pBuffSys, pNxCoreSys, 100);
		if (pNxCoreSys->Status == NxCORESTATUS_LOADED_STATE) {//on state load filter symbols
			NxCore.SpinSymbols(NxSPIN_ALL_EXGS, NxSPIN_NON_OPTIONS, 0, OnNxCoreCallbackSetReverseLookup, 0);
			NxCore.SpinSymbols(NxSPIN_ALL_EXGS, NxSPIN_OPTIONS, 0, OnNxCoreCallbackSetReverseLookup, 0);
			bBeforeSpin = 0;
		}
		if (pNxCoreSys->Status == NxCORESTATUS_SYMBOLSPIN && pNxCoreSys->StatusData == NxCSSYMBOLSPIN_COMPLETE)//symbol spin is done all existing symbols have been filtered
			bBeforeSpin = 0;
		if (!jStringPermissionSet) {
			jstring jPermission = env->NewStringUTF(pNxCoreSys->PermissionSet);
			jStringPermissionSet = env->NewGlobalRef(jPermission);
			env->DeleteLocalRef(jPermission);
		}
		env->SetObjectArrayElement(jStringStausArray, 0, jStringPermissionSet);
		ret = env->CallIntMethod(objectIface, methodStatus, jStringStausArray);

		break;
	case NxMSG_EXGQUOTE:
		if (!checkSymbol(pNxCoreMsg))
			return NxCALLBACKRETURN_CONTINUE;
		memcpy(pBuffCoreHeader, &pNxCoreMsg->coreHeader, 56);
		memcpy(pBuffExg, &pNxCoreMsg->coreData.ExgQuote, 88);
		memcpy(pBuffSymbolUserData, pNxCoreMsg->coreHeader.pnxStringSymbol, 10);

		if (pNxCoreMsg->coreHeader.pnxOptionHdr == nullptr) {
			jStringSymbol = GetjStringSymbol(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.ListedExg);
			ret = env->CallIntMethod(objectIface, methodExgQuoteEquity, jStringSymbol);
		}
		else {
			pOption = GetjStringOption(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.pnxOptionHdr);
			memcpy(pBuffOptionHeader, pNxCoreMsg->coreHeader.pnxOptionHdr, 64);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pBuffContractUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, 10);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pBuffUnderlyingUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, 10);
			ret = env->CallIntMethod(objectIface, methodExgQuoteOption, pOption->jSymbol, GetjStringDateAndStrike(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike), pOption->jUnderlying, pOption->jSeriesChain, pOption->jSpecialSettle);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, pBuffContractUserData, 8);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, pBuffUnderlyingUserData, 8);
		}
		memcpy(pNxCoreMsg->coreHeader.pnxStringSymbol, pBuffSymbolUserData, 8);
		break;
	case NxMSG_MMQUOTE:
		if (!checkSymbol(pNxCoreMsg))
			return NxCALLBACKRETURN_CONTINUE;
		memcpy(pBuffCoreHeader, &pNxCoreMsg->coreHeader, 56);
		memcpy(pBuffMM, &pNxCoreMsg->coreData.MMQuote, 52);
		memcpy(pBuffSymbolUserData, pNxCoreMsg->coreHeader.pnxStringSymbol, 10);

		jStringMM = GetjStringMM(pNxCoreMsg->coreData.MMQuote.pnxStringMarketMaker);

		if (pNxCoreMsg->coreHeader.pnxOptionHdr == nullptr) {
			jStringSymbol = GetjStringSymbol(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.ListedExg);
			ret = env->CallIntMethod(objectIface, methodMMQuoteEquity, jStringMM, jStringSymbol);
		}
		else {
			pOption = GetjStringOption(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.pnxOptionHdr);
			memcpy(pBuffOptionHeader, pNxCoreMsg->coreHeader.pnxOptionHdr, 64);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pBuffContractUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, 10);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pBuffUnderlyingUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, 10);
			ret = env->CallIntMethod(objectIface, methodMMQuoteOption, jStringMM, pOption->jSymbol, GetjStringDateAndStrike(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike), pOption->jUnderlying, pOption->jSeriesChain, pOption->jSpecialSettle);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, pBuffContractUserData, 8);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, pBuffUnderlyingUserData, 8);
		}
		memcpy(pNxCoreMsg->coreHeader.pnxStringSymbol, pBuffSymbolUserData, 8);
		break;
	case NxMSG_TRADE:
		if (!checkSymbol(pNxCoreMsg))
			return NxCALLBACKRETURN_CONTINUE;
		memcpy(pBuffCoreHeader, &pNxCoreMsg->coreHeader, 56);
		memcpy(pBuffTrade, &pNxCoreMsg->coreData.Trade, 88);
		memcpy(pBuffSymbolUserData, pNxCoreMsg->coreHeader.pnxStringSymbol, 10);

		if (pNxCoreMsg->coreHeader.pnxOptionHdr == nullptr) {
			jStringSymbol = GetjStringSymbol(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.ListedExg);
			ret = env->CallIntMethod(objectIface, methodTradeEquity, jStringSymbol);
		}
		else {
			pOption = GetjStringOption(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.pnxOptionHdr);
			memcpy(pBuffOptionHeader, pNxCoreMsg->coreHeader.pnxOptionHdr, 64);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pBuffContractUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, 10);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pBuffUnderlyingUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, 10);
			ret = env->CallIntMethod(objectIface, methodTradeOption, pOption->jSymbol, GetjStringDateAndStrike(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike), pOption->jUnderlying, pOption->jSeriesChain, pOption->jSpecialSettle);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, pBuffContractUserData, 8);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, pBuffUnderlyingUserData, 8);
		}
		memcpy(pNxCoreMsg->coreHeader.pnxStringSymbol, pBuffSymbolUserData, 8);
		break;
	case NxMSG_CATEGORY:
		if (!checkSymbol(pNxCoreMsg))
			return NxCALLBACKRETURN_CONTINUE;
		memcpy(pBuffCoreHeader, &pNxCoreMsg->coreHeader, 56);
		pnxFields = pNxCoreMsg->coreData.Category.pnxFields;
		for (int i = 0; i < min((int)pNxCoreMsg->coreData.Category.NFields, 256); i++) {
			if (!pnxFields[i].Set)
				continue;
			jstring jCategoryString;
			if (pnxFields[i].FieldType == NxCFT_NxSTRING && pnxFields[i].data.pnxString) {
				jCategoryString = env->NewStringUTF(pnxFields[i].data.pnxString->String);
				env->SetObjectArrayElement(CategoryDataString, i, jCategoryString);
				env->DeleteLocalRef(jCategoryString);
			}
			else if (pnxFields[i].FieldType == NxCFT_STRINGZ && pnxFields[i].data.StringZ) {
				jCategoryString = env->NewStringUTF(pnxFields[i].data.StringZ);
				env->SetObjectArrayElement(CategoryDataString, i, jCategoryString);
				env->DeleteLocalRef(jCategoryString);
			}
		}
		memcpy(pBuffCategory, pnxFields, sizeof(NxCategoryField) * min(256, (int)pNxCoreMsg->coreData.Category.NFields));
		memcpy(pBuffSymbolUserData, pNxCoreMsg->coreHeader.pnxStringSymbol, 10);

		if (pNxCoreMsg->coreHeader.pnxOptionHdr == nullptr) {
			jStringSymbol = GetjStringSymbol(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.ListedExg);
			ret = env->CallIntMethod(objectIface, methodCategoryEquity, pNxCoreMsg->coreData.Category.pnxStringCategory->Atom, pNxCoreMsg->coreData.Category.NFields, GetjStringCategory(pNxCoreMsg->coreData.Category.pnxStringCategory, pNxCoreMsg->coreData.Category.pnxStringCategory->Atom), GetjArrayCategoryFieldName(pnxFields, pNxCoreMsg->coreData.Category.NFields, pNxCoreMsg->coreData.Category.pnxStringCategory->Atom), GetjArrayCategoryFieldInfo(pnxFields, pNxCoreMsg->coreData.Category.NFields, pNxCoreMsg->coreData.Category.pnxStringCategory->Atom), CategoryDataString, jStringSymbol);
		}
		else {
			pOption = GetjStringOption(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.pnxOptionHdr);
			memcpy(pBuffOptionHeader, pNxCoreMsg->coreHeader.pnxOptionHdr, 64);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pBuffContractUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, 10);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pBuffUnderlyingUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, 10);
			ret = env->CallIntMethod(objectIface, methodCategoryOption, pNxCoreMsg->coreData.Category.pnxStringCategory->Atom, pNxCoreMsg->coreData.Category.NFields, GetjStringCategory(pNxCoreMsg->coreData.Category.pnxStringCategory, pNxCoreMsg->coreData.Category.pnxStringCategory->Atom), GetjArrayCategoryFieldName(pnxFields, pNxCoreMsg->coreData.Category.NFields, pNxCoreMsg->coreData.Category.pnxStringCategory->Atom), GetjArrayCategoryFieldInfo(pnxFields, pNxCoreMsg->coreData.Category.NFields, pNxCoreMsg->coreData.Category.pnxStringCategory->Atom), CategoryDataString, pOption->jSymbol, GetjStringDateAndStrike(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike), pOption->jUnderlying, pOption->jSeriesChain, pOption->jSpecialSettle);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, pBuffContractUserData, 8);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, pBuffUnderlyingUserData, 8);
		}
#ifdef CHECK_EXCEPTIONS
		if (env->ExceptionCheck()) { env->ExceptionDescribe(); env->ExceptionClear(); }
#endif
		for (int i = 0; i < min((int)pNxCoreMsg->coreData.Category.NFields, 256); i++) {
			if (!pnxFields[i].Set)
				continue;
			if ((pnxFields[i].FieldType == NxCFT_NxSTRING && pnxFields[i].data.pnxString) || (pnxFields[i].FieldType == NxCFT_STRINGZ && pnxFields[i].data.StringZ)) {
				env->DeleteLocalRef(env->GetObjectArrayElement(CategoryDataString, i));
				env->SetObjectArrayElement(CategoryDataString, i, jStringNull);
			}
		}
		memcpy(pNxCoreMsg->coreHeader.pnxStringSymbol, pBuffSymbolUserData, 8);
		break;
	case NxMSG_SYMBOLCHANGE:
		if (symbolFilterEnable) {
			SetSymbolFilterUserData(pNxCoreMsg);
			if (pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 != 1)
				return NxCALLBACKRETURN_CONTINUE;
		}
		memcpy(pBuffCoreHeader, &pNxCoreMsg->coreHeader, 56);
		memcpy(pBuffSymbolChange, &pNxCoreMsg->coreData.SymbolChange, 32);
		memcpy(pBuffSymbolUserData, pNxCoreMsg->coreHeader.pnxStringSymbol, 10);




		if (pNxCoreMsg->coreHeader.pnxOptionHdr == nullptr) {
			jobject jStringSymbolOld = nullptr;
			jStringSymbol = GetjStringSymbol(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.ListedExg);
			if (pNxCoreMsg->coreData.SymbolChange.pnxsSymbolOld)
				jStringSymbolOld = GetjStringSymbolOld(pNxCoreMsg->coreData.SymbolChange.pnxsSymbolOld, pNxCoreMsg->coreData.SymbolChange.ListedExgOld);
			ret = env->CallIntMethod(objectIface, methodSymbolChangeEquity, jStringSymbolOld, jStringSymbol);
		}
		else if (pNxCoreMsg->coreHeader.pnxOptionHdr) {
			OptionLookupResult* pOptionOld = nullptr;
			pOption = GetjStringOption(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.pnxOptionHdr);
			SymbolNxStringLookup[10][std::string(pNxCoreMsg->coreHeader.pnxStringSymbol->String) + std::to_string(pNxCoreMsg->coreHeader.pnxOptionHdr->nxExpirationDate.NDays).append(1, pNxCoreMsg->coreHeader.pnxOptionHdr->PutCall == 0 ? 'C' : 'P') + std::to_string(pNxCoreMsg->coreHeader.pnxOptionHdr->strikePrice)] = (size_t)pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike;
			if (pNxCoreMsg->coreData.SymbolChange.pnxOptionHdrOld && pNxCoreMsg->coreData.SymbolChange.pnxsSymbolOld) {
				pOptionOld = GetjStringOption(pNxCoreMsg->coreData.SymbolChange.pnxsSymbolOld, pNxCoreMsg->coreData.SymbolChange.pnxOptionHdrOld);
				memcpy(pBuffSymbolChangeOption, pNxCoreMsg->coreData.SymbolChange.pnxOptionHdrOld, 64);
			}
			memcpy(pBuffOptionHeader, pNxCoreMsg->coreHeader.pnxOptionHdr, 64);

			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pBuffContractUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, 10);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pBuffUnderlyingUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, 10);
			ret = env->CallIntMethod(objectIface, methodSymbolChangeOption, pOptionOld ? pOptionOld->jSymbol : nullptr, pOption->jSymbol, GetjStringDateAndStrike(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike), pOption->jUnderlying, pOption->jSeriesChain, pOption->jSpecialSettle, pOptionOld ? GetjStringDateAndStrike(pNxCoreMsg->coreData.SymbolChange.pnxOptionHdrOld->pnxsDateAndStrike) : nullptr, pOptionOld ? pOptionOld->jUnderlying : nullptr, pOptionOld ? pOptionOld->jSeriesChain : nullptr, pOptionOld ? pOptionOld->jSpecialSettle : nullptr);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, pBuffContractUserData, 8);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, pBuffUnderlyingUserData, 8);
		}
		memcpy(pNxCoreMsg->coreHeader.pnxStringSymbol, pBuffSymbolUserData, 8);
		break;
	case NxMSG_SYMBOLSPIN:
		if (symbolFilterEnable) {
			SetSymbolFilterUserData(pNxCoreMsg);
			if (pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 != 1)
				return NxCALLBACKRETURN_CONTINUE;
		}
		memcpy(pBuffCoreHeader, &pNxCoreMsg->coreHeader, 56);
		memcpy(pBuffSymbolSpin, &pNxCoreMsg->coreData.SymbolSpin, 20);
		memcpy(pBuffSymbolUserData, pNxCoreMsg->coreHeader.pnxStringSymbol, 10);



		if (pNxCoreMsg->coreHeader.pnxOptionHdr == nullptr) {
			jStringSymbol = GetjStringSymbol(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.ListedExg);
			ret = env->CallIntMethod(objectIface, methodSymbolSpinEquity, jStringSymbol);
		}
		else {
			pOption = GetjStringOption(pNxCoreMsg->coreHeader.pnxStringSymbol, pNxCoreMsg->coreHeader.pnxOptionHdr);
			SymbolNxStringLookup[10][std::string(pNxCoreMsg->coreHeader.pnxStringSymbol->String) + std::to_string(pNxCoreMsg->coreHeader.pnxOptionHdr->nxExpirationDate.NDays).append(1, pNxCoreMsg->coreHeader.pnxOptionHdr->PutCall == 0 ? 'C' : 'P') + std::to_string(pNxCoreMsg->coreHeader.pnxOptionHdr->strikePrice)] = (size_t)pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike;
			memcpy(pBuffOptionHeader, pNxCoreMsg->coreHeader.pnxOptionHdr, 64);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pBuffContractUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, 10);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pBuffUnderlyingUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, 10);
			ret = env->CallIntMethod(objectIface, methodSymbolSpinOption, pOption->jSymbol, GetjStringDateAndStrike(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike), pOption->jUnderlying, pOption->jSeriesChain, pOption->jSpecialSettle);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, pBuffContractUserData, 8);
			if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
				memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, pBuffUnderlyingUserData, 8);
		}
		memcpy(pNxCoreMsg->coreHeader.pnxStringSymbol, pBuffSymbolUserData, 8);
		break;
	}
#ifdef CHECK_EXCEPTIONS
	if (env->ExceptionCheck()) { env->ExceptionDescribe(); env->ExceptionClear(); }
#endif
	return ret;
}
};
void clearLookup(robin_hood::unordered_flat_map<size_t, jobject>* plookup, ThreadData* pTD) {
	for (auto iter = plookup->begin(); iter != plookup->end(); iter++) {
		if (iter->second)
			pTD->env->DeleteGlobalRef(iter->second);
	}
	plookup->clear();
}
void clearOptionLookup(OptionLookupResult* pResult, ThreadData* pTD) {
	pTD->env->DeleteGlobalRef(pResult->jSymbol);
	pTD->env->DeleteGlobalRef(pResult->jUnderlying);
	pTD->env->DeleteGlobalRef(pResult->jSpecialSettle);
	pTD->env->DeleteGlobalRef(pResult->jSeriesChain);
	delete pResult;
}
jobject inline LocalToGlobalRef(jobject lobj, ThreadData* pTD) {
	jobject gobj = pTD->env->NewGlobalRef(lobj);
	pTD->env->DeleteLocalRef(lobj);
	return gobj;
}
jobjectArray inline LocalToGlobalRef(jobjectArray lobj, ThreadData* pTD) {
	jobjectArray gobj = (jobjectArray)pTD->env->NewGlobalRef(lobj);
	pTD->env->DeleteLocalRef(lobj);
	return gobj;
}

thread_local ThreadData td;

int __stdcall OnNxCoreCallbackSetReverseLookup(const NxCoreSystem* pNxCoreSys, const NxCoreMessage* pNxCoreMsg) {
	return td.SetReverseLookup(pNxCoreSys, pNxCoreMsg);
}
int __stdcall OnNxCoreCallback(const NxCoreSystem* pNxCoreSys, const NxCoreMessage* pNxCoreMsg) {
	return td.Callback(pNxCoreSys, pNxCoreMsg);
}



JNIEXPORT jint JNICALL Java_net_nanex_NxCoreClass_ProcessTape(JNIEnv* env, jobject thisObj, jstring StringFilename, jlong pMemoryAddr, jint controlFlags, jint UserData) {
	ThreadData* pTD = &td;
	const char* pszFilename;
	int         retVal;

	if (!pTD->bLoadedLibrary)
		return NxAPIERR_EXCEPTION;
	jclass objclass = env->GetObjectClass(thisObj);
	pTD->StringClass = env->FindClass("java/lang/String");
	pTD->jStringNull= env->NewGlobalRef(env->NewStringUTF(pTD->charNull));
	pTD->env = env;
	pTD->objectIface = thisObj;
	pTD->bBeforeSpin = 1;
	//Get the functions we will call

	pTD->methodStatus = env->GetMethodID(objclass, "cbStatus", "([Ljava/lang/String;)I");
	pTD->methodExgQuoteEquity = env->GetMethodID(objclass, "cbExgQuoteEquity", "(Ljava/lang/String;)I");
	pTD->methodExgQuoteOption = env->GetMethodID(objclass, "cbExgQuoteOption", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodMMQuoteEquity = env->GetMethodID(objclass, "cbMMQuoteEquity", "(Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodMMQuoteOption = env->GetMethodID(objclass, "cbMMQuoteOption", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodTradeEquity = env->GetMethodID(objclass, "cbTradeEquity", "(Ljava/lang/String;)I");
	pTD->methodTradeOption = env->GetMethodID(objclass, "cbTradeOption", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodCategoryEquity = env->GetMethodID(objclass, "cbCategoryEquity", "(IILjava/lang/String;[Ljava/lang/String;[Ljava/lang/String;[Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodCategoryOption = env->GetMethodID(objclass, "cbCategoryOption", "(IILjava/lang/String;[Ljava/lang/String;[Ljava/lang/String;[Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodSymbolChangeEquity = env->GetMethodID(objclass, "cbSymbolChangeEquity", "(Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodSymbolChangeOption = env->GetMethodID(objclass, "cbSymbolChangeOption", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodSymbolSpinEquity = env->GetMethodID(objclass, "cbSymbolSpinEquity", "(Ljava/lang/String;)I");
	pTD->methodSymbolSpinOption = env->GetMethodID(objclass, "cbSymbolSpinOption", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodUserSymbolSpinEquity = env->GetMethodID(objclass, "cbUserSymbolSpinEquity", "(Ljava/lang/String;)I");
	pTD->methodUserSymbolSpinOption = env->GetMethodID(objclass, "cbUserSymbolSpinOption", "(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodUserTapeList = env->GetMethodID(objclass, "cbTapeList", "(Ljava/lang/String;Ljava/lang/String;)I");
	pTD->methodUserAPIList = env->GetMethodID(objclass, "cbAPIList", "(Ljava/lang/String;)I");

	// Get the Java direct byte buffers we will be copying data into
	jobject jBuffSys = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_Sys", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffExg = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_ExgQuote", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffMM = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_MMQuote", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffTrade = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_Trade", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffCategory = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_Category", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffSymbolChange = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_SymbolChange", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffChangeOptionHeader = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_SymbolChangeOptionHdr", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffSymbolSpin = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_SymbolSpin", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffCoreHeader = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_coreHeader", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffOptionHeader = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_NxOptionHdr", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffSymbolUserData = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_SymbolUserData", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffContractUserData = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_ContractUserData", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffUnderlyingUserData = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_UnderlyingUserData", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffState = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_State", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffDate = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_Date", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffTapeFile = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_TapeFileInfo", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffAPIDLLFile = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_APIDLLFileInfo", "Ljava/nio/ByteBuffer;")), pTD);
	jobject jBuffNxCore3Ext = LocalToGlobalRef(env->GetObjectField(thisObj, env->GetFieldID(objclass, "m_NxCore3Ext", "Ljava/nio/ByteBuffer;")), pTD);
	pTD->pBuffSys = (char*)env->GetDirectBufferAddress(jBuffSys);
	pTD->pBuffExg = (char*)env->GetDirectBufferAddress(jBuffExg);
	pTD->pBuffMM =(char*) env->GetDirectBufferAddress( jBuffMM);
	pTD->pBuffTrade = (char*)env->GetDirectBufferAddress(jBuffTrade);
	pTD->pBuffCategory = (char*)env->GetDirectBufferAddress(jBuffCategory);
	pTD->pBuffSymbolChange = (char*)env->GetDirectBufferAddress(jBuffSymbolChange);
	pTD->pBuffSymbolChangeOption = (char*)env->GetDirectBufferAddress(jBuffChangeOptionHeader);
	pTD->pBuffSymbolSpin = (char*)env->GetDirectBufferAddress(jBuffSymbolSpin);
	pTD->pBuffCoreHeader = (char*)env->GetDirectBufferAddress( jBuffCoreHeader);
	pTD->pBuffOptionHeader = (char*)env->GetDirectBufferAddress( jBuffOptionHeader);
	pTD->pBuffSymbolUserData = (char*)env->GetDirectBufferAddress(jBuffSymbolUserData);
	pTD->pBuffContractUserData = (char*)env->GetDirectBufferAddress(jBuffContractUserData);
	pTD->pBuffUnderlyingUserData = (char*)env->GetDirectBufferAddress(jBuffUnderlyingUserData);
	pTD->pBuffState = (char*)env->GetDirectBufferAddress(jBuffState);
	pTD->pBuffDate = (NxDate*)env->GetDirectBufferAddress(jBuffDate);
	pTD->pBuffTapeFile = (NxCoreTapeFile*)env->GetDirectBufferAddress(jBuffTapeFile);
	pTD->pBuffAPIDLLFile = (NxCoreAPIDLLFile*)env->GetDirectBufferAddress(jBuffAPIDLLFile);
	pTD->pBuffNxCore3Ext = (NxCore3Ext*)env->GetDirectBufferAddress(jBuffNxCore3Ext);

	// Create the arrays we will be using to pass strings to Java
	pTD->jStringStausArray = LocalToGlobalRef(env->NewObjectArray(1, pTD->StringClass, pTD->jStringNull), pTD);
	pTD->CategoryDataString = LocalToGlobalRef(env->NewObjectArray(256, pTD->StringClass, pTD->jStringNull), pTD);
	pTD->MMStateString = LocalToGlobalRef(env->NewObjectArray(512, pTD->StringClass, pTD->jStringNull), pTD);
	pTD->EmptyArray = LocalToGlobalRef(env->NewObjectArray(0, pTD->StringClass, pTD->jStringNull), pTD);

	pszFilename = env->GetStringUTFChars(StringFilename, 0);
	retVal=NxCore.ProcessTape(pszFilename,(char*) pMemoryAddr,(int) controlFlags,(int) UserData, OnNxCoreCallback);
	//release the memory of what JNI held on to.
	env->ReleaseStringUTFChars(StringFilename, pszFilename);
	env->DeleteGlobalRef(jBuffSys);
	env->DeleteGlobalRef(jBuffExg);
	env->DeleteGlobalRef(jBuffMM);
	env->DeleteGlobalRef(jBuffTrade);
	env->DeleteGlobalRef(jBuffCategory);
	env->DeleteGlobalRef(jBuffSymbolChange);
	env->DeleteGlobalRef(jBuffChangeOptionHeader);
	env->DeleteGlobalRef(jBuffSymbolSpin);
	env->DeleteGlobalRef(jBuffCoreHeader);
	env->DeleteGlobalRef(jBuffOptionHeader);
	env->DeleteGlobalRef(jBuffSymbolUserData);
	env->DeleteGlobalRef(jBuffContractUserData);
	env->DeleteGlobalRef(jBuffUnderlyingUserData);
	env->DeleteGlobalRef(jBuffState);
	env->DeleteGlobalRef(jBuffDate);
	env->DeleteGlobalRef(jBuffTapeFile);
	env->DeleteGlobalRef(jBuffAPIDLLFile);
	env->DeleteGlobalRef(jBuffNxCore3Ext);
	env->DeleteGlobalRef(pTD->jStringStausArray);
	env->DeleteGlobalRef(pTD->CategoryDataString);
	env->DeleteGlobalRef(pTD->MMStateString);
	env->DeleteGlobalRef(pTD->EmptyArray);
	for (int i = 0; i < 256; i++) {
		clearLookup(&(pTD->SymbolLookup[i]), pTD);
		clearLookup(&(pTD->SymbolLookupOld[i]), pTD);
		pTD->SymbolNxStringLookup[i].clear();
		if(pTD->CategoryFieldNameLookup[i])
			pTD->env->DeleteGlobalRef(pTD->CategoryFieldNameLookup[i]);
		if (pTD->CategoryFieldInfoLookup[i])
			pTD->env->DeleteGlobalRef(pTD->CategoryFieldInfoLookup[i]);
		if (pTD->CategoryLookup[i])
			pTD->env->DeleteGlobalRef(pTD->CategoryLookup[i]);
		pTD->CategoryFieldNameLookup[i] = nullptr;
		pTD->CategoryFieldInfoLookup[i] = nullptr;
		pTD->CategoryLookup[i] = nullptr;
		if (pTD->SymbolLookupAtom[i]) {
			for (int j = 0; j < 65536; j++) {
				if (pTD->SymbolLookupAtom[i][j]) {
					env->DeleteGlobalRef(pTD->SymbolLookupAtom[i][j]);
				}
			}
			delete pTD->SymbolLookupAtom[i];
			pTD->SymbolLookupAtom[i] = nullptr;
		}
		clearLookup(&(pTD->DefinedStringLookup[i]), pTD);
	}
	for (int i = 0; i < 65536; i++) {
		if (pTD->DateAndStrikeLookup[i]) {
			pTD->DateAndStrikeLookup[i] = nullptr;
		}
		if (pTD->OptionLookupAtom[i]) {
			clearOptionLookup(pTD->OptionLookupAtom[i], pTD);
			pTD->OptionLookupAtom[i] = nullptr;
		}
	}
	for (auto i = pTD->OptionLookup.begin(); i != pTD->OptionLookup.end(); i++)
		if (i->second)
			clearOptionLookup(i->second, pTD);
	pTD->OptionLookup.clear();
	clearLookup(&pTD->MMLookup, pTD);
	pTD->env->DeleteGlobalRef(pTD->jStringPermissionSet);
	pTD->jStringPermissionSet = nullptr;
	pTD->env->DeleteGlobalRef(pTD->jStringNull);
	return retVal;
}
JNIEXPORT jint JNICALL Java_net_nanex_NxCoreClass_LoadNxCore(JNIEnv* env, jobject thisObj, jstring StringNxCoreLib) {
	ThreadData* pTD = &td;
	const char* cszNxCoreLib;
	int         retVal;
	pTD->bLoadedLibrary = 0;
	cszNxCoreLib = env->GetStringUTFChars(StringNxCoreLib, 0);
	retVal = NxCore.LoadNxCore(cszNxCoreLib);
	env->ReleaseStringUTFChars(StringNxCoreLib, cszNxCoreLib);
	if(retVal)
		pTD->bLoadedLibrary = 1;
	return retVal;
}
JNIEXPORT void JNICALL Java_net_nanex_NxCoreClass_UnloadNxCore(JNIEnv* env, jobject thisObj) {
	ThreadData* pTD = &td;
	NxCore.UnloadNxCore();
	pTD->bLoadedLibrary = 0;
	return;
}
JNIEXPORT jint JNICALL Java_net_nanex_NxCoreClass_APIVersion(JNIEnv* env, jobject thisObj) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return NxAPIERR_EXCEPTION;
	return NxCore.APIVersion();
}
void JNICALL Java_net_nanex_NxCoreClass_SetSystemUserData(JNIEnv* env, jobject thisObj, jint UserData) {
	ThreadData* pTD = &td;
	pTD->m_pNxCoreSys->UserData = UserData;
}
JNIEXPORT jint JNICALL Java_net_nanex_NxCoreClass_SaveState(JNIEnv* env, jobject thisObj, jstring szStateFilename, jint controlFlags) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return NxAPIERR_EXCEPTION;
	return NxCore.SaveState(pTD->env->GetStringUTFChars(szStateFilename, NULL), controlFlags);
}
JNIEXPORT jstring JNICALL Java_net_nanex_NxCoreClass_GetDefinedString(JNIEnv* env, jobject thisObj, jint ixTable, jint ixString) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return (jstring)pTD->jStringNull;
	jstring jString;
	if (pTD->DefinedStringLookup[ixTable][ixString]) {
		return (jstring)pTD->DefinedStringLookup[ixTable][ixString];
	}
	const char* pTableItem = NxCore.GetDefinedString(ixTable, ixString);
	if (pTableItem == nullptr)
		return(jstring) pTD->jStringNull;
	jString = pTD->env->NewStringUTF(pTableItem);
	pTD->DefinedStringLookup[ixTable][ixString] =(jstring) pTD->env->NewGlobalRef(jString);
	pTD->env->DeleteLocalRef(jString);
	return jString;
}
JNIEXPORT jint JNICALL Java_net_nanex_NxCoreClass_ExcludeOpraExch(JNIEnv* env, jobject thisObj, jint opraId) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return NxAPIERR_EXCEPTION;
	return NxCore.ExcludeOpraExch(opraId);
}
JNIEXPORT jint JNICALL Java_net_nanex_NxCoreClass_GetSymbolAtom32(JNIEnv* env, jobject thisObj) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return NxAPIERR_EXCEPTION;
	return NxCore.GetSymbolAtom32();
}
jint Java_net_nanex_NxCoreClass_NativeGetExgQuotes(JNIEnv* env, jobject thisObj, jint exg, jstring jSymbol) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return 1;
	NxString* pNxSymbolString;
	NxCoreStateExgQuotes StateExgQuotes;
	if ((pNxSymbolString = pTD->GetjNxStringSymbol(jSymbol, exg))) {
		if (NxCore.StateGetExgQuotes(&StateExgQuotes, pNxSymbolString)==0) {//returns 0 on success
			StateExgQuotes.StateQuoteCount = min((int)StateExgQuotes.StateQuoteCount, 24);
			memcpy(pTD->pBuffState, &StateExgQuotes, 8 + sizeof(NxCoreStateExgQuote) * StateExgQuotes.StateQuoteCount);
			return 0;
		}
	}
	return 1;
}
jobjectArray Java_net_nanex_NxCoreClass_NativeGetMMQuotes(JNIEnv* env, jobject thisObj, jint reportingExg, jint exg, jstring jSymbol) {
	ThreadData* pTD = &td;
	NxString* pNxSymbolString;
	if (!pTD->bLoadedLibrary)
		return pTD->EmptyArray;
	// NxCoreStateMMQuotes is over 16KB don't want to keep it in stack
	if ((pNxSymbolString = pTD->GetjNxStringSymbol(jSymbol, exg))) {
		if (NxCore.StateGetMMQuotes(reportingExg,(NxCoreStateMMQuotes*)pTD->pBuffState, pNxSymbolString) == 0) {//returns 0 on success
			((NxCoreStateMMQuotes*)pTD->pBuffState)->StateQuoteCount = min((int)((NxCoreStateMMQuotes*)pTD->pBuffState)->StateQuoteCount, 512);
			jstring jMarketMaker;
			for (int i = 0; i < ((NxCoreStateMMQuotes*)pTD->pBuffState)->StateQuoteCount; i++) {
				if (((NxCoreStateMMQuotes*)pTD->pBuffState)->StateMMQuotes[i].pnxStringMarketMaker) {
					jMarketMaker = env->NewStringUTF(((NxCoreStateMMQuotes*)pTD->pBuffState)->StateMMQuotes[i].pnxStringMarketMaker->String);
					env->SetObjectArrayElement(pTD->MMStateString, i, jMarketMaker);
					env->DeleteLocalRef(jMarketMaker);
				}
				else
					env->SetObjectArrayElement(pTD->MMStateString, i, pTD->jStringNull);
			}
			return pTD->MMStateString;
		}
	}
	return pTD->EmptyArray;
}
jint Java_net_nanex_NxCoreClass_NativeGetLastTrade(JNIEnv* env, jobject thisObj, jint exg, jstring jSymbol) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return 1;
	NxString* pNxSymbolString;
	NxCoreStateTrade StateTrade;
	if ((pNxSymbolString = pTD->GetjNxStringSymbol(jSymbol, exg))) {
		if (NxCore.StateGetLastTrade(&StateTrade, pNxSymbolString) == 0) {//returns 0 on success
			memcpy(pTD->pBuffState, &StateTrade,sizeof(NxCoreStateTrade));
			return 0;
		}
	}
	return 1;
}
JNIEXPORT jstring JNICALL Java_net_nanex_NxCoreClass_GetTapeName(JNIEnv* env, jobject thisObj){
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return nullptr;
	char tapename[MAX_PATH];
	if(NxCore.GetTapeName(tapename, MAX_PATH)>=0)
		return env->NewStringUTF(tapename);
	return nullptr;
}
JNIEXPORT jint JNICALL Java_net_nanex_NxCoreClass_PriceConvert(JNIEnv* env, jobject thisObj, jint lPrice, jint PriceType, jint PriceTypeNew) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return NxAPIERR_EXCEPTION;
	return NxCore.PriceConvert(lPrice, PriceType, PriceTypeNew);
}
JNIEXPORT jstring JNICALL Java_net_nanex_NxCoreClass_PriceFormat(JNIEnv* env, jobject thisObj, jint lPrice, jint PriceType, jint expandWidth, jboolean bCommas) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return nullptr;
	char buffer[256];
	if(expandWidth<256 &&NxCore.PriceFormat(buffer,lPrice, PriceType, expandWidth, bCommas)>0)
		return env->NewStringUTF(buffer);
	return nullptr;
}
JNIEXPORT void JNICALL Java_net_nanex_NxCoreClass_NativeDateFromNDays(JNIEnv* env, jobject thisObj, jint NDays) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		memset(pTD->pBuffDate, 0, sizeof(NxDate));
	pTD->pBuffDate->NDays = NDays;
	if (!pTD->bLoadedLibrary)
		return;
	NxCore.DateFromNDays(pTD->pBuffDate);
}
JNIEXPORT void JNICALL Java_net_nanex_NxCoreClass_NativeDateFromYMD(JNIEnv* env, jobject thisObj, jint Year, jint Month, jint Day){
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		memset(pTD->pBuffDate, 0, sizeof(NxDate));
	pTD->pBuffDate->Year = Year;
	pTD->pBuffDate->Month = Month;
	pTD->pBuffDate->Day = Day;
	if (!pTD->bLoadedLibrary)
		return;
	NxCore.DateFromYMD(pTD->pBuffDate);
}

int __stdcall OnNxCoreCallbackTapeList(void* pYourParam, const NxCoreTapeFile* pNcTF) {
	ThreadData* pTD = &td;
	memcpy(pTD->pBuffTapeFile, pNcTF,sizeof(NxCoreTapeFile));
	int ret = pTD->env->CallIntMethod(pTD->objectIface, pTD->methodUserTapeList, pTD->env->NewStringUTF(pNcTF->PathnameStrZ),pTD->env->NewStringUTF(pNcTF->PermSet));
#ifdef CHECK_EXCEPTIONS
	if (pTD->env->ExceptionCheck())pTD->env->ExceptionDescribe();
#endif
	return ret;
}
JNIEXPORT jint JNICALL Java_net_nanex_NxCoreClass_ListTapes(JNIEnv* env, jobject thisObj, jint controlFlags){
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return NxAPIERR_EXCEPTION;
	return NxCore.ListTapes(controlFlags, OnNxCoreCallbackTapeList,0);
}

int __stdcall OnNxCoreCallbackAPIList(void* pYourParam, const NxCoreAPIDLLFile* pNcTF) {
	ThreadData* pTD = &td;
	memcpy(pTD->pBuffAPIDLLFile, pNcTF, 316);//don't memcpy padding will overflow buffer
	int ret = pTD->env->CallIntMethod(pTD->objectIface, pTD->methodUserAPIList, pTD->env->NewStringUTF(pNcTF->PathnameStrZ));
#ifdef CHECK_EXCEPTIONS
	if (pTD->env->ExceptionCheck())pTD->env->ExceptionDescribe();
#endif
	return ret;
}
JNIEXPORT jint JNICALL Java_net_nanex_NxCoreClass_ListAPIDLLs(JNIEnv* env, jobject thisObj, jint controlFlags) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return NxAPIERR_EXCEPTION;
	return NxCore.ListAPIDLLs(controlFlags, OnNxCoreCallbackAPIList, 0);
}
int __stdcall OnNxCoreCallbackSymbolSpin(const NxCoreSystem* pNxCoreSys, const NxCoreMessage* pNxCoreMsg) {
	ThreadData* pTD = &td;
	int retValue = 0;
	if (pTD->symbolFilterEnable && pNxCoreMsg->coreHeader.pnxStringSymbol->UserData2 != 1)
		return NxCALLBACKRETURN_CONTINUE;
	memcpy(pTD->pBuffCoreHeader, &pNxCoreMsg->coreHeader, 56);
	memcpy(pTD->pBuffSymbolSpin, &pNxCoreMsg->coreData.SymbolSpin, 20);
	memcpy(pTD->pBuffSymbolUserData, pNxCoreMsg->coreHeader.pnxStringSymbol, 10);

	if (pNxCoreMsg->coreHeader.pnxOptionHdr == nullptr) {
		pTD->SymbolNxStringLookup[pNxCoreMsg->coreHeader.ListedExg][std::string(pNxCoreMsg->coreHeader.pnxStringSymbol->String)] = (size_t)pNxCoreMsg->coreHeader.pnxStringSymbol;
		retValue=pTD->env->CallIntMethod(pTD->objectIface, pTD->methodUserSymbolSpinEquity, pTD->env->NewStringUTF(pNxCoreMsg->coreHeader.pnxStringSymbol->String));
#ifdef CHECK_EXCEPTIONS
		if (pTD->env->ExceptionCheck())pTD->env->ExceptionDescribe();
#endif
	}
	else {
		jobject jUnderlying= nullptr;
		jobject jSeriesChain= nullptr;
		jobject jSpecialSettle= nullptr;
		jobject jSymbol = pTD->env->NewStringUTF(pNxCoreMsg->coreHeader.pnxStringSymbol->String);
		if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying) {
			jUnderlying = pTD->env->NewStringUTF(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying->String);
		}
		if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsSeriesChain) {
			jSeriesChain = pTD->env->NewStringUTF(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsSeriesChain->String);
		}
		if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsSpecialSettle) {
			jSpecialSettle = pTD->env->NewStringUTF(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsSpecialSettle->String);
		}
		char DateAndStrike[3];
		strncpy(DateAndStrike, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike->String, 2);
		DateAndStrike[2] = 0;
		jobject jDateAndStrike = pTD->env->NewStringUTF(DateAndStrike);
		pTD->SymbolNxStringLookup[10][std::string(pNxCoreMsg->coreHeader.pnxStringSymbol->String) + std::to_string(pNxCoreMsg->coreHeader.pnxOptionHdr->nxExpirationDate.NDays).append(1, pNxCoreMsg->coreHeader.pnxOptionHdr->PutCall == 0 ? 'C' : 'P') + std::to_string(pNxCoreMsg->coreHeader.pnxOptionHdr->strikePrice)] = (size_t)pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike;
		memcpy(pTD->pBuffOptionHeader, pNxCoreMsg->coreHeader.pnxOptionHdr, 64);
		if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
			memcpy(pTD->pBuffContractUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, 10);
		if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
			memcpy(pTD->pBuffUnderlyingUserData, pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, 10);
		retValue=pTD->env->CallIntMethod(pTD->objectIface, pTD->methodUserSymbolSpinOption, jSymbol, jDateAndStrike, jUnderlying, jSeriesChain, jSpecialSettle);
#ifdef CHECK_EXCEPTIONS
		if (pTD->env->ExceptionCheck())pTD->env->ExceptionDescribe();
#endif
		if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike)
			memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsDateAndStrike, pTD->pBuffContractUserData, 8);
		if (pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying)
			memcpy(pNxCoreMsg->coreHeader.pnxOptionHdr->pnxsUnderlying, pTD->pBuffUnderlyingUserData, 8);
	}
	memcpy(pNxCoreMsg->coreHeader.pnxStringSymbol, pTD->pBuffSymbolUserData, 8);
	return retValue;
}
JNIEXPORT jint JNICALL Java_net_nanex_NxCoreClass_SpinSymbols(JNIEnv* env, jobject thisObj, jint ListedExg, jint controlFlags, jint spinID, jint tempUserData) {
	ThreadData* pTD = &td;
	if (!pTD->bLoadedLibrary)
		return NxAPIERR_EXCEPTION;
	return NxCore.SpinSymbols(ListedExg, controlFlags, spinID, OnNxCoreCallbackSymbolSpin, tempUserData );
}
JNIEXPORT void JNICALL Java_net_nanex_NxCoreClass_ProcessReturnValue(JNIEnv* env, jobject thisObj, jint returnValue) {
	NxCore.ProcessReturnValue(returnValue);
}
JNIEXPORT jboolean JNICALL Java_net_nanex_NxCoreClass_FilterSymbols___3Ljava_lang_String_2(JNIEnv* env, jobject thisObj, jobjectArray symbolArray) {
	ThreadData* pTD = &td;
	pTD->symbolFilterLookup.clear();
	pTD->symbolFilterEnable = 0;
	jsize len=env->GetArrayLength(symbolArray);
	jobject jSymbol;
	const char* pszSymbol;
	for (int i = 0; i < len; i++) {
		jSymbol = env->GetObjectArrayElement(symbolArray, i);
		if (!env->IsInstanceOf(jSymbol,env->FindClass("java/lang/String")))
			return false;
		pszSymbol = env->GetStringUTFChars((jstring)jSymbol, 0);
		pTD->symbolFilterLookup[std::string(pszSymbol)] = 256;
		env->ReleaseStringUTFChars((jstring)jSymbol, pszSymbol);
	}
	pTD->symbolFilterEnable = 1;
	return true;
}
JNIEXPORT jboolean JNICALL Java_net_nanex_NxCoreClass_FilterSymbols__Ljava_lang_String_2(JNIEnv* env, jobject thisObj, jstring jSymbol) {
	ThreadData* pTD = &td;
	pTD->symbolFilterLookup.clear();
	const char* pszSymbol;
	pszSymbol = env->GetStringUTFChars(jSymbol, 0);
	pTD->symbolFilterLookup[std::string(pszSymbol)] = 256;
	env->ReleaseStringUTFChars(jSymbol, pszSymbol);
	pTD->symbolFilterEnable = 1;
	return true;
}
JNIEXPORT jboolean JNICALL Java_net_nanex_NxCoreClass_FilterSymbolsRange(JNIEnv* env, jobject thisObj, jstring jStartSymbol, jstring jEndSymbol) {
	ThreadData* pTD = &td;
	const char* pszStartSymbol;
	const char* pszEndSymbol;
	pszStartSymbol = env->GetStringUTFChars(jStartSymbol, 0);
	pszEndSymbol = env->GetStringUTFChars(jEndSymbol, 0);
	pTD->StartSymbol = std::string(pszStartSymbol);
	pTD->EndSymbol = std::string(pszEndSymbol);
	env->ReleaseStringUTFChars(jStartSymbol, pszStartSymbol);
	env->ReleaseStringUTFChars(jEndSymbol, pszEndSymbol);
	pTD->symbolFilterEnable = 3;
	return true;
}
JNIEXPORT jboolean JNICALL Java_net_nanex_NxCoreClass_ExcludeSymbols___3Ljava_lang_String_2(JNIEnv* env, jobject thisObj, jobjectArray symbolArray) {
	ThreadData* pTD = &td;
	pTD->symbolExcludeLookup.clear();
	pTD->symbolFilterEnable = 0;
	jsize len = env->GetArrayLength(symbolArray);
	jobject jSymbol;
	const char* pszSymbol;
	for (int i = 0; i < len; i++) {
		jSymbol = env->GetObjectArrayElement(symbolArray, i);
		if (!env->IsInstanceOf(jSymbol, env->FindClass("java/lang/String")))
			return false;
		pszSymbol = env->GetStringUTFChars((jstring)jSymbol, 0);
		pTD->symbolExcludeLookup[std::string(pszSymbol)] = 256;
		env->ReleaseStringUTFChars((jstring)jSymbol, pszSymbol);
	}
	pTD->symbolFilterEnable = 2;
	return true;
}
JNIEXPORT jboolean JNICALL Java_net_nanex_NxCoreClass_ExcludeSymbols__Ljava_lang_String_2(JNIEnv* env, jobject thisObj, jstring jSymbol) {
	ThreadData* pTD = &td;
	pTD->symbolExcludeLookup.clear();
	const char* pszSymbol;
	pszSymbol = env->GetStringUTFChars(jSymbol, 0);
	pTD->symbolExcludeLookup[std::string(pszSymbol)] = 256;
	env->ReleaseStringUTFChars(jSymbol, pszSymbol);
	pTD->symbolFilterEnable = 2;
	return true;
}