import NxCore

#path to the nx2 file, or leave blank for real-time using NxCore Access
filepath = ""

def OnNxCoreStatus(NxCoreSys, NxCoreMsg):
	if NxCoreSys.ClockUpdateInterval >= NxCore.NxCLOCK_MINUTE and NxCoreSys.nxTime.Hour < 24:
		print("{:02d}/{:02d}/{:04d} {:02d}:{:02d}:{:02d}".format(NxCoreSys.nxDate.Month, NxCoreSys.nxDate.Day, NxCoreSys.nxDate.Year, NxCoreSys.nxTime.Hour, NxCoreSys.nxTime.Minute, NxCoreSys.nxTime.Second))
	if NxCoreSys.Status == NxCore.NxCORESTATUS_RUNNING:
		return
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_COMPLETE:
		print("NxCore Complete Message.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_INITIALIZING:
		print("NxCore Initialize Message.")
		print("API version is v{}.{}.{}".format(NxCore.GetMajorVersion(NxCoreSys.DLLVersion), NxCore.GetMinorVersion(NxCoreSys.DLLVersion), NxCore.GetBuildVersion(NxCoreSys.DLLVersion)))
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_WAITFORCOREACCESS:
		print("NxCore Wait For Access.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_ERROR:
		print("NxCore Error.")
	return

def OnNxCoreSymbolSpin(NxCoreSys, NxCoreMsg):
	if NxCoreMsg.coreHeader.pnxOptionHdr and NxCoreMsg.coreHeader.pnxStringSymbol.String[0] == 'o':#option symbol
		pnxOptionHdr = NxCoreMsg.coreHeader.pnxOptionHdr #pnxOptionHdr contains details of contract
		StrikePrice = pnxOptionHdr.strikePrice / 1000
		
		if NxCoreMsg.coreHeader.pnxOptionHdr.pnxsDateAndStrike.String[1] == ' ':#current option format
			OptionSymbol = "{:>6}{:02d}{:02d}{:02d}{}{:08d}".format(NxCoreMsg.coreHeader.pnxStringSymbol.String[1:], pnxOptionHdr.nxExpirationDate.Year-2000, pnxOptionHdr.nxExpirationDate.Month,pnxOptionHdr.nxExpirationDate.Day, "C" if pnxOptionHdr.PutCall == 0 else "P", pnxOptionHdr.strikePrice)
		else: #older option format
			OptionSymbol = "{}{}".format(pnxStringSymbol.String[1:], pnxOptionHdr.pnxsDateAndStrike.String[:2])
		print("Symbol: {} Strike: {:.2f} Underlying: {} Series Chain: {}".format(OptionSymbol, StrikePrice, pnxOptionHdr.pnxsUnderlying.String if pnxOptionHdr.pnxsUnderlying else "",pnxOptionHdr.pnxsSeriesChain.String if pnxOptionHdr.pnxsSeriesChain else ""))
	else: #non-option symbol
		print("Symbol: {} Listed Exg: {}".format(NxCoreMsg.coreHeader.pnxStringSymbol.String, NxCoreMsg.coreHeader.ListedExg))

def OnNxCoreCallback(NxCoreSys, NxCoreMsg):
	if NxCoreMsg.MessageType == NxCore.NxMSG_STATUS:
		OnNxCoreStatus(NxCoreSys, NxCoreMsg)
	elif NxCoreMsg.MessageType == NxCore.NxMSG_SYMBOLSPIN:
		OnNxCoreSymbolSpin(NxCoreSys, NxCoreMsg)
	return NxCore.NxCALLBACKRETURN_CONTINUE

print("NxCore SampleApp02 Start.")
if NxCore.LoadNxCore("../NxCoreAPI64.dll"):
	NxCore.ProcessTape(filepath, 0, 0, 0, OnNxCoreCallback)
else:
	print("Failed to load NxCore Library")