import NxCore

#path to the nx2 file, or leave blank for real-time using NxCore Access
filepath = ""

def OnNxCoreStatus(NxCoreSys, NxCoreMsg):
	if NxCoreSys.ClockUpdateInterval >= NxCore.NxCLOCK_MINUTE and NxCoreSys.nxTime.Hour < 24:
		print("{:02d}/{:02d}/{:04d} {:02d}:{:02d}:{:02d}".format(NxCoreSys.nxDate.Month, NxCoreSys.nxDate.Day, NxCoreSys.nxDate.Year, NxCoreSys.nxTime.Hour, NxCoreSys.nxTime.Minute, NxCoreSys.nxTime.Second))
	if NxCoreSys.Status == NxCore.NxCORESTATUS_RUNNING:
		return
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_COMPLETE:
		print("NxCore Complete Message.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_INITIALIZING:
		print("NxCore Initialize Message.")
		print("API version is v{}.{}.{}".format(NxCore.GetMajorVersion(NxCoreSys.DLLVersion), NxCore.GetMinorVersion(NxCoreSys.DLLVersion), NxCore.GetBuildVersion(NxCoreSys.DLLVersion)))
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_WAITFORCOREACCESS:
		print("NxCore Wait For Access.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_ERROR:
		print("NxCore Error.")
	return

def OnNxCoreCategory(NxCoreSys, NxCoreMsg):
	Category = NxCoreMsg.coreData.Category
	CategoryID = Category.pnxStringCategory.Atom

	if CategoryID == 4:#Equity Symbol Information
		field = Category.pnxFields[0]
		if field.Set:
			print("Category 4 for Symbol: {}, Company Name= {}".format(NxCoreMsg.coreHeader.pnxStringSymbol.String, field.data.StringZ))
	elif CategoryID == 13:#52 Week High/Low
		HighDate = ""
		LowDate = ""
		High = 0
		Low = 0

		#Grab 52 week high date
		field = Category.pnxFields[0];
		if field.Set:
			HighDate = "{:02d}/{:02d}/{:04d}".format(field.data.nxDate.Month, field.data.nxDate.Day, field.data.nxDate.Year)

		#Grab 52 week low date
		field = Category.pnxFields[1];
		if field.Set:
			LowDate = "{:02d}/{:02d}/{:04d}".format(field.data.nxDate.Month, field.data.nxDate.Day, field.data.nxDate.Year)

		#Grab 52 week high price
		field = Category.pnxFields[2];
		if field.Set:
			High = NxCore.PriceToFloat(field.data.nxPrice.Price, field.data.nxPrice.PriceType)
			
		#Grab 52 week low price
		field = Category.pnxFields[3];
		if field.Set:
			Low = NxCore.PriceToFloat(field.data.nxPrice.Price, field.data.nxPrice.PriceType)
		print("Category 13 for Symbol: {}, {} High52= {:.2f}, {} Low52= {:.2f}".format(NxCoreMsg.coreHeader.pnxStringSymbol.String, HighDate, High, LowDate, Low))

def OnNxCoreCallback(NxCoreSys,NxCoreMsg):
	if NxCoreMsg.MessageType == NxCore.NxMSG_STATUS:
		OnNxCoreStatus(NxCoreSys, NxCoreMsg)
	elif NxCoreMsg.MessageType == NxCore.NxMSG_CATEGORY:
		OnNxCoreCategory(NxCoreSys, NxCoreMsg)
	return NxCore.NxCALLBACKRETURN_CONTINUE

print("NxCore SampleApp03 Start.")
if NxCore.LoadNxCore("../NxCoreAPI64.dll"):
	NxCore.ProcessTape(filepath, 0, 0, 0, OnNxCoreCallback)
else:
	print("Failed to load NxCore Library")