import NxCore

#path to the nx2 file, or leave blank for real-time using NxCore Access
filepath = ""

def OnUserListTapes(NxTF):
	print("Filename: " + NxTF.PathnameStrZ)

def OnUserListAPI(NxDF):
	print("Filename: " + NxDF.PathnameStrZ)

def OnUserSymbolSpin(NxCoreSys, NxCoreMsg):
	print("UserSymbol Spin for: {} Listed Exg: {}".format(NxCoreMsg.coreHeader.pnxStringSymbol.String, NxCoreMsg.coreHeader.ListedExg))
	return NxCore.NxCALLBACKRETURN_CONTINUE

def OnUserSymbolSpinOptions( NxCoreSys, NxCoreMsg):
	if NxCoreMsg.coreHeader.pnxOptionHdr:
		pnxOptionHdr = NxCoreMsg.coreHeader.pnxOptionHdr
		StrikePrice = pnxOptionHdr.strikePrice / 1000
		if pnxOptionHdr.pnxsDateAndStrike.String[1] == ' ':
			print("UserSymbol Spin for: {:>6}{:02d}{:02d}{:02d}{}{:08d}".format(NxCoreMsg.coreHeader.pnxStringSymbol.String[1:], pnxOptionHdr.nxExpirationDate.Year-2000, pnxOptionHdr.nxExpirationDate.Month, pnxOptionHdr.nxExpirationDate.Day, "C" if pnxOptionHdr.PutCall == 0 else "P", pnxOptionHdr.strikePrice))
		else:
			print("UserSymbol Spin for: {}{}".format(pnxStringSymbol.String[1:], pnxOptionHdr.pnxsDateAndStrike.String[:2]))
	return NxCore.NxCALLBACKRETURN_CONTINUE

def OnNxCoreStatus(NxCoreSys, NxCoreMsg):
	if NxCoreSys.ClockUpdateInterval >= NxCore.NxCLOCK_MINUTE and NxCoreSys.nxTime.Hour < 24:
		print("{:02d}/{:02d}/{:04d} {:02d}:{:02d}:{:02d}".format(NxCoreSys.nxDate.Month, NxCoreSys.nxDate.Day, NxCoreSys.nxDate.Year, NxCoreSys.nxTime.Hour, NxCoreSys.nxTime.Minute, NxCoreSys.nxTime.Second))
	if NxCoreSys.Status == NxCore.NxCORESTATUS_RUNNING:
		return
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_SYMBOLSPIN and NxCoreSys.StatusData == NxCore.NxCSSYMBOLSPIN_COMPLETE:
		print("NxCore Initial Spin Complete Message.")
		input("Press <Enter> to run a user define spin.")
		NxCore.SpinSymbols(NxCore.NxSPIN_ALL_EXGS, NxCore.NxSPIN_NON_OPTIONS, 1, OnUserSymbolSpin, 0)
		NxCore.SpinSymbols(NxCore.NxSPIN_ALL_EXGS, NxCore.NxSPIN_OPTIONS, 1, OnUserSymbolSpinOptions, 0)
		print("UserDefine Spin Complete!")

		input("Press <Enter> to get available NxCore data files.")
		NxCore.ListTapes(NxCore.NxLTF_SEARCH_LOCAL, OnUserListTapes)

		input("Press <Enter> to get available NxCore API files.")
		NxCore.ListAPIDLLs(0, OnUserListAPI)

		input("Press <Enter> to get defined strings for exchanges.")
		for i in range(0,68):
			print("Exg #" + str(i) + " = "+NxCore.GetDefinedString(NxCore.NxST_EXCHANGE, i))

		input("Press <Enter> to get the Tape Name.")
		print("TapeName " + NxCore.GetTapeName())

		input("Press <Enter> to continue with tape.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_COMPLETE:
		print("NxCore Complete Message.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_INITIALIZING:
		print("NxCore Initialize Message.")
		print("API version is v{}.{}.{}".format(NxCore.GetMajorVersion(NxCoreSys.DLLVersion), NxCore.GetMinorVersion(NxCoreSys.DLLVersion), NxCore.GetBuildVersion(NxCoreSys.DLLVersion)))
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_WAITFORCOREACCESS:
		print("NxCore Wait For Access.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_ERROR:
		print("NxCore Error.")
	return

def OnNxCoreCallback(NxCoreSys, NxCoreMsg):
	if NxCoreMsg.MessageType == NxCore.NxMSG_STATUS:
		OnNxCoreStatus(NxCoreSys, NxCoreMsg)
	return NxCore.NxCALLBACKRETURN_CONTINUE

print("NxCore SampleApp07 Start.")
if NxCore.LoadNxCore("../NxCoreAPI64.dll"):
	NxCore.ProcessTape(filepath, 0, 0, 0, OnNxCoreCallback)
else:
	print("Failed to load NxCore Library")