import NxCore

#path to the nx2 file, or leave blank for real-time using NxCore Access
filepath = ""
counter = 0

def OnNxCoreSymbolSpin(NxCoreSys, NxCoreMsg):
	global counter
	#assign a number to UserData1, up to 32 bits. UserData2 can also be used if not using the FilterSymbols function
	if NxCoreMsg.coreHeader.pnxOptionHdr:
		NxCoreMsg.coreHeader.pnxOptionHdr.pnxsDateAndStrike.UserData1 = counter
	else:
		NxCoreMsg.coreHeader.pnxStringSymbol.UserData1 = counter
	counter += 1

def OnUserSymbolSpin_Options(NxCoreSys, NxCoreMsg):
	pnxOptionHdr = NxCoreMsg.coreHeader.pnxOptionHdr
	if pnxOptionHdr:
		if NxCoreMsg.coreHeader.pnxOptionHdr.pnxsDateAndStrike.String[1] == ' ' :#current option format
			OptionSymbol = "{:>6}{:02d}{:02d}{:02d}{}{:08d}".format(NxCoreMsg.coreHeader.pnxStringSymbol.String[1:], pnxOptionHdr.nxExpirationDate.Year-2000, pnxOptionHdr.nxExpirationDate.Month, pnxOptionHdr.nxExpirationDate.Day, "C" if pnxOptionHdr.PutCall == 0 else "P", pnxOptionHdr.strikePrice)
		else: #older option format
			OptionSymbol="{}{}".format(pnxStringSymbol.String[1:], pnxOptionHdr.pnxsDateAndStrike.String[:2])
		print("UserSymbol Spin OPRA Sym: {}  UserData1={}".format(OptionSymbol, NxCoreMsg.coreHeader.pnxOptionHdr.pnxsDateAndStrike.UserData1))
	return NxCore.NxCALLBACKRETURN_CONTINUE

def OnUserSymbolSpin_NonOptions(NxCoreSys, NxCoreMsg):
	print("UserSymbol Spin for: {} Listed Exg: {}  UserData1={}".format(NxCoreMsg.coreHeader.pnxStringSymbol.String, NxCoreMsg.coreHeader.ListedExg, NxCoreMsg.coreHeader.pnxStringSymbol.UserData1))
	return NxCore.NxCALLBACKRETURN_CONTINUE

def OnNxCoreStatus(NxCoreSys, NxCoreMsg):
	if NxCoreSys.ClockUpdateInterval >= NxCore.NxCLOCK_MINUTE and NxCoreSys.nxTime.Hour < 24:
		print("{:02d}/{:02d}/{:04d} {:02d}:{:02d}:{:02d}".format(NxCoreSys.nxDate.Month, NxCoreSys.nxDate.Day, NxCoreSys.nxDate.Year, NxCoreSys.nxTime.Hour, NxCoreSys.nxTime.Minute, NxCoreSys.nxTime.Second))
	if NxCoreSys.Status == NxCore.NxCORESTATUS_RUNNING:
		return
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_SYMBOLSPIN and NxCoreSys.StatusData == NxCore.NxCSSYMBOLSPIN_COMPLETE:
		print("NxCore Initial Spin Complete Message.")
		input("Press <Enter> to run a user define spin for non-options.")
		NxCore.SpinSymbols(NxCore.NxSPIN_ALL_EXGS, NxCore.NxSPIN_NON_OPTIONS, 1, OnUserSymbolSpin_NonOptions, 0)

		print("NxCore non-options User Spin Complete Message.")
		input("Press <Enter> to run a user define spin for options.")
		NxCore.SpinSymbols(NxCore.NxSPIN_ALL_EXGS,NxCore.NxSPIN_OPTIONS, 1, OnUserSymbolSpin_Options, 0)
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_COMPLETE:
		print("NxCore Complete Message.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_INITIALIZING:
		print("NxCore Initialize Message.")
		print("API version is v{}.{}.{}".format(NxCore.GetMajorVersion(NxCoreSys.DLLVersion), NxCore.GetMinorVersion(NxCoreSys.DLLVersion), NxCore.GetBuildVersion(NxCoreSys.DLLVersion)))
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_WAITFORCOREACCESS:
		print("NxCore Wait For Access.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_ERROR:
		print("NxCore Error.")
	return

def OnNxCoreCallback(NxCoreSys, NxCoreMsg):
	if NxCoreMsg.MessageType == NxCore.NxMSG_STATUS:
		OnNxCoreStatus(NxCoreSys, NxCoreMsg)
	elif NxCoreMsg.MessageType== NxCore.NxMSG_SYMBOLSPIN:
		OnNxCoreSymbolSpin(NxCoreSys, NxCoreMsg)
	return NxCore.NxCALLBACKRETURN_CONTINUE

print("NxCore SampleApp08 Start.")
if NxCore.LoadNxCore("../NxCoreAPI64.dll"):
	NxCore.ProcessTape(filepath, 0, 0, 0, OnNxCoreCallback)
else:
	print("Failed to load NxCore Library")