import NxCore

#path to the nx2 file, or leave blank for real-time using NxCore Access
filepath = ""
def MicroOfDayToString(MicroOfDay):
	SecondOfDay = MicroOfDay/1000000
	Hour = SecondOfDay/(60*60)
	Minute = SecondOfDay/60%60
	Second = SecondOfDay%60
	MicroOfSec = MicroOfDay%1000000
	return "{:02d}:{:02d}:{:02d}.{:06d}".format(Hour, Minute, Second, MicroOfSec)
def OnNxCoreStatus(NxCoreSys, NxCoreMsg):
	if NxCoreSys.ClockUpdateInterval >= NxCore.NxCLOCK_MINUTE and NxCoreSys.nxTime.Hour < 24:
		print("{:02d}/{:02d}/{:04d} {:02d}:{:02d}:{:02d}".format(NxCoreSys.nxDate.Month, NxCoreSys.nxDate.Day, NxCoreSys.nxDate.Year, NxCoreSys.nxTime.Hour, NxCoreSys.nxTime.Minute, NxCoreSys.nxTime.Second))
	if NxCoreSys.Status == NxCore.NxCORESTATUS_RUNNING:
		return
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_COMPLETE:
		print("NxCore Complete Message.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_INITIALIZING:
		print("NxCore Initialize Message.")
		print("API version is v{}.{}.{}".format(NxCore.GetMajorVersion(NxCoreSys.DLLVersion), NxCore.GetMinorVersion(NxCoreSys.DLLVersion), NxCore.GetBuildVersion(NxCoreSys.DLLVersion)))
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_WAITFORCOREACCESS:
		print("NxCore Wait For Access.")
	elif NxCoreSys.Status == NxCore.NxCORESTATUS_ERROR:
		print("NxCore Error.")
	return

def OnNxCoreTrade(NxCoreSys, NxCoreMsg):
	if NxCoreMsg.coreHeader.pnxStringSymbol.String[0] == 'e':
		Trade = NxCoreMsg.coreData.Trade
		Price = NxCore.PriceToFloat(Trade.Price,Trade.PriceType)
		NetChange = NxCore.PriceToFloat(Trade.NetChange, Trade.PriceType)
		Size = Trade.Size
		print("Trade for Symbol: {}, Time: {:02d}:{:02d}:{:02d} Price: {:.2f} NetChg: {:.2f} Size: {} Exchg: {} TC: ( {} )".format(NxCoreMsg.coreHeader.pnxStringSymbol.String, NxCoreMsg.coreHeader.nxExgTimestamp.Hour, NxCoreMsg.coreHeader.nxExgTimestamp.Minute, NxCoreMsg.coreHeader.nxExgTimestamp.Second, Price, NetChange, Size, NxCoreMsg.coreHeader.ReportingExg, Trade.TradeCondition), end="")
		if Trade.ExtTradeConditions[0]:
			print(" ({},{},{},{})".format(Trade.ExtTradeConditions[0], Trade.ExtTradeConditions[1], Trade.ExtTradeConditions[2], Trade.ExtTradeConditions[3], end=""))
		print()
		if NxCoreMsg.pnxCore3Ext:
			print("[SRC TIME: {}] [PTP1 TIME: {}] [PTP2 TIME: {}]".format(MicroOfDayToString(NxCoreMsg.pnxCore3Ext.MicrosOfDaySRC), MicroOfDayToString(NxCoreMsg.pnxCore3Ext.MicrosOfDayPTP1), MicroOfDayToString(NxCoreMsg.pnxCore3Ext.MicrosOfDayPTP2)))
def OnNxCoreCallback(NxCoreSys, NxCoreMsg):
	if NxCoreMsg.MessageType == NxCore.NxMSG_STATUS:
		OnNxCoreStatus(NxCoreSys, NxCoreMsg)
	elif NxCoreMsg.MessageType == NxCore.NxMSG_TRADE:
		OnNxCoreTrade(NxCoreSys, NxCoreMsg)
	return NxCore.NxCALLBACKRETURN_CONTINUE

print("NxCore SampleApp11 Start.")
if NxCore.LoadNxCore("../NxCoreAPI64.dll"):
	NxCore.ProcessTape(filepath, 0, 0, 0, OnNxCoreCallback)
else:
	print("Failed to load NxCore Library")