import net.nanex.NxCoreClass;
class SampleApp01 extends NxCoreClass{
	public static void main(String args[]) {
		SampleApp01 NxCore= new SampleApp01();
		int returnValue;
		if(args.length < 1) {
			System.out.println("SampleApp01 dll-file [tape-name]");
			return;
		}
		System.out.println("NxCore Java SampleApp01 Start.");
		
		// If we can load the NxCore API
		if(NxCore.LoadNxCore(args[0])!=0) {
			// If a tape filename was passed in command line argument,
			// call ProcessTape with that argument. Use control flags
			// to eliminate Level1 quotes, Level2 quotes and all OPRA
			// quotes.
			if (args.length > 1){
				System.out.println("Processing the tape: " + args[1]);
				returnValue = NxCore.ProcessTape(args[1], 0, (SampleApp01.defines.NxCF_EXCLUDE_QUOTES | SampleApp01.defines.NxCF_EXCLUDE_QUOTES2 | SampleApp01.defines.NxCF_EXCLUDE_OPRA), 0);
			} else {
				returnValue = NxCore.ProcessTape("", 0, (SampleApp01.defines.NxCF_EXCLUDE_QUOTES | SampleApp01.defines.NxCF_EXCLUDE_QUOTES2 | SampleApp01.defines.NxCF_EXCLUDE_OPRA), 0);
			}
			// output return value from processTape(), helps in troubleshooting potential issues
			NxCore.ProcessReturnValue(returnValue);
			
			// Unload NxCore DLL
			NxCore.UnloadNxCore();
		}
		else {
			System.out.println("Failed to load NxCore Library");
			return;
		}
		System.out.println("NxCore C++ SampleApp01 Stop.");
	}
	
	void OnNxCoreStatus(NxCoreSystem NxCoreSys,NxCoreMessage NxCoreMsg)
	{
		// If a Minute has elapsed print the NxCore system time.
		// NOTE: The last time sent is 24:00:00. 24:00:00 is not actually
		// a real time value
		if ((NxCoreSys.ClockUpdateInterval >= defines.NxCLOCK_MINUTE) &&(NxCoreSys.nxTime.Hour < 24))
		{
			System.out.printf("%02d/%02d/%04d %02d:%02d:%02d\n",
					NxCoreSys.nxDate.Month,
					NxCoreSys.nxDate.Day,
					NxCoreSys.nxDate.Year,
					NxCoreSys.nxTime.Hour,
					NxCoreSys.nxTime.Minute,
					NxCoreSys.nxTime.Second);
		}

		// Print the specific NxCore status message
		switch (NxCoreSys.Status) {
		case defines.NxCORESTATUS_COMPLETE:
			System.out.println("NxCore Complete Message.");
			break;

		case defines.NxCORESTATUS_INITIALIZING:
			System.out.println("NxCore Initialize Message.");
			System.out.println("API version is v" + GetMajorVersion(NxCoreSys.DLLVersion) + "." + GetMinorVersion(NxCoreSys.DLLVersion) + "." + GetBuildVersion(NxCoreSys.DLLVersion) );
			break;

		case defines.NxCORESTATUS_SYNCHRONIZING:
			System.out.println("NxCore Synchronizing Message.");
			break;

		case defines.NxCORESTATUS_WAITFORCOREACCESS:
			System.out.println("NxCore Wait For Access.");
			break;

		case defines.NxCORESTATUS_RESTARTING_TAPE:
			System.out.println("NxCore Restart Tape Message.");
			break;

		case defines.NxCORESTATUS_ERROR:
			System.out.println("NxCore Error.");
			break;

		case defines.NxCORESTATUS_RUNNING:
			break;
			
		}
	}
	
	@Override
	public int OnNxCoreCallback( NxCoreSystem NxCoreSys, NxCoreMessage NxCoreMsg){
		  // If this is an NxCore Status message pass it to the status
		  // message handler function.
		  if (NxCoreMsg.MessageType == defines.NxMSG_STATUS)
			 OnNxCoreStatus(NxCoreSys,NxCoreMsg);

		  // Continue running the tape
		  return defines.NxCALLBACKRETURN_CONTINUE;
	}
}