import net.nanex.NxCoreClass;
class SampleApp09 extends NxCoreClass{
	NxDate[] nxdates = {new NxDate(),new NxDate(),new NxDate()};
	public static void main(String args[]) {
		SampleApp09 NxCore= new SampleApp09();
		int returnValue;
		if(args.length < 1) {
			System.out.println("SampleApp09 dll-file [tape-name]");
			return;
		}
		System.out.println("NxCore Java SampleApp09 Start.");
		
		// If we can load the NxCore API
		if(NxCore.LoadNxCore(args[0])!=0) {
			int dateIndex = 2;
			NxCore.nxdates[dateIndex].Day = 1;
			NxCore.nxdates[dateIndex].Month = 6;
			NxCore.nxdates[dateIndex].Year = 2010;
			// If a tape filename was passed in command line argument,
			// call ProcessTape with that argument.
			if (args.length > 1){
				System.out.println("Processing the tape: " + args[1]);
				returnValue = NxCore.ProcessTape(args[1], 0, 0, dateIndex);
			} else {
				returnValue = NxCore.ProcessTape("", 0, 0, dateIndex);
			}
			// output return value from processTape(), helps in troubleshooting potential issues
			NxCore.ProcessReturnValue(returnValue);
			
			// Unload NxCore DLL
			NxCore.UnloadNxCore();
		}
		else {
			System.out.println("Failed to load NxCore Library");
			return;
		}
		System.out.println("NxCore C++ SampleApp09 Stop.");
	}
		
	@Override
	public int OnNxCoreCallback( NxCoreSystem NxCoreSys, NxCoreMessage NxCoreMsg){
		  // Grab the data in UserData 
		  int dateIndex = NxCoreSys.UserData;
		  System.out.println(dateIndex);
		  // Print out custom data
		  System.out.println("UserData Date: " +
				String.format("%02d", nxdates[dateIndex].Month) + "/" +
				String.format("%02d", nxdates[dateIndex].Day) + "/" +
				String.format("%04d", nxdates[dateIndex].Year) + " " );
		
		// Continue running the tape
		return defines.NxCALLBACKRETURN_STOP;
	}
}